<?php
//  ---------------------------------------------------------------------------------
//    _____   _             _                   _   _____
//   |  __ \ | |           | |    /\           (_) |  __ \
//   | |__) || |__    __ _ | |   /  \    _ __   _  | |__) |_ __  ___
//   |  ___/ | '_ \  / _` || |  / /\ \  | '_ \ | | |  ___/| '__|/ _ \
//   | |     | | | || (_| || | / ____ \ | |_) || | | |    | |  | (_) |
//   |_|     |_| |_| \__,_||_|/_/    \_\| .__/ |_| |_|    |_|   \___/
//                                      | |
//                                      |_|
//   PhalApi Pro 专业版
//   广州果创网络科技有限公司
//
//  ---------------------------------------------------------------------------------
//
//   一、协议的许可和权利
//    1. 您可以在完全遵守本协议的基础上，将本软件应用于商业用途；
//    2. 您可以在协议规定的约束和限制范围内修改本产品源代码或界面风格以适应您的要求；
//    3. 您拥有使用本产品中的全部内容资料、商品信息及其他信息的所有权，并独立承担与其内容相关的
//       法律义务；
//    4. 获得商业授权之后，您可以将本软件应用于商业用途，自授权时刻起，在技术支持期限内拥有通过
//       指定的方式获得指定范围内的技术支持服务；
//
//   二、协议的约束和限制
//    1. 未获商业授权之前，禁止将本软件用于商业用途（包括但不限于企业法人经营的产品、经营性产品
//       以及以盈利为目的或实现盈利产品）；
//    2. 未获商业授权之前，禁止在本产品的整体或在任何部分基础上发展任何派生版本、修改版本或第三
//       方版本用于重新开发；
//    3. 如果您未能遵守本协议的条款，您的授权将被终止，所被许可的权利将被收回并承担相应法律责任；
//
//   三、有限担保和免责声明
//    1. 本软件及所附带的文件是作为不提供任何明确的或隐含的赔偿或担保的形式提供的；
//    2. 用户出于自愿而使用本软件，您必须了解使用本软件的风险，在尚未获得商业授权之前，我们不承
//       诺提供任何形式的技术支持、使用担保，也不承担任何因使用本软件而产生问题的相关责任；
//    3. 广州果创网络科技有限公司不对使用本产品构建的商城中的内容信息承担责任，但在不侵犯用户隐
//       私信息的前提下，保留以任何方式获取用户信息及商品信息的权利；
//
//   有关本产品最终用户授权协议、商业授权与技术服务的详细内容，均由广州果创网络科技有限公司独家
//   提供。广州果创网络科技有限公司拥有在不事先通知的情况下，修改授权协议的权力，修改后的协议对
//   改变之日起的新授权用户生效。电子文本形式的授权协议如同双方书面签署的协议一样，具有完全的和
//   等同的法律效力。您一旦开始修改、安装或使用本产品，即被视为完全理解并接受本协议的各项条款，
//   在享有上述条款授予的权力的同时，受到相关的约束和限制。协议许可范围以外的行为，将直接违反本
//   授权协议并构成侵权，我们有权随时终止授权，责令停止损害，并保留追究相关责任的权力。
//
//  ---------------------------------------------------------------------------------

namespace Admin\Api;

use Admin\Common\Api;
use Base\Common\ApiInfoUtil;
use Base\Domain\User as UserDomain;
use Base\Domain\Apps as AppsDomain;
use Base\Domain\Rights as RightsDomain;
use Base\Domain\RightsService as RightsServiceDomain;
use PhalApi\Exception\BadRequestException;

/**
 * 应用接口权限模块
 */
class Rights extends Api {

    public function getRules() {
        return array(
            'getAllAppApis' => array(
                'appKey' => array('name' => 'app_key', 'require' => true, 'default' => '', 'max' => 100, 'desc' => '应用key'),
            ),
            'assignRights' => array(
                'appKey' => array('name' => 'app_key', 'require' => true, 'default' => '', 'max' => 100, 'desc' => '应用key'),
                'assignService' => array('name' => 'assign_service', 'require' => true, 'type' => 'array', 'format' => 'explode', 'seperator' => ',', 'desc' => '本次授权的接口服务，多个用英文逗号分割'),
            ),
            'removeRights' => array(
                'appKey' => array('name' => 'app_key', 'require' => true, 'default' => '', 'max' => 100, 'desc' => '应用key'),
                'removeService' => array('name' => 'remove_service', 'require' => true, 'type' => 'array', 'format' => 'explode', 'seperator' => ',', 'desc' => '本次取消授权的接口服务，多个用英文逗号分割'),
            ),
            'addRightsService' => array(
                'rightsService' => array('name' => 'rights_service', 'require' => true, 'max' => 150, 'desc' => '接口服务'),
                'serviceDesc' => array('name' => 'service_desc', 'default' => '', 'max' => 1000, 'desc' => '描述'),
            ),
            'removeRightsService' => array(
                'rightsService' => array('name' => 'rights_service', 'require' => true, 'max' => 150, 'desc' => '待删除的接口服务'),
            ),
            'assignRightsForDevTypeOrNot' => array(
                'rightsService' => array('name' => 'rights_service', 'require' => true, 'max' => 150, 'desc' => '待指派或撤销的接口服务'),
                'memberType' => array('name' => 'member_type', 'require' => true, 'desc' => '开发者账号类型'),
            ),
            'searchRightsList' => array(
                'rightsService' => array('name' => 'rights_service', 'default' => '', 'max' => 150, 'desc' => '接口服务'),
                'memberType' => array('name' => 'member_type', 'default' => 0, 'desc' => '开发者账号类型'),
                'userId' => array('name' => 'user_id', 'type' => 'int', 'default' => 0, 'desc' => '账号ID'),
                'appKey' => array('name' => 'app_key', 'default' => '', 'max' => 100, 'desc' => '应用key'),
                'page' => array('name' => 'page', 'type' => 'int', 'min' => 1, 'default' => 1, 'desc' => '第几页'),
                'perpage' => array('name' => 'perpage', 'type' => 'int', 'min' => 1, 'max' => 5000, 'default' => 10, 'desc' => '分页数量'),
            ),
            'assignRightsOrNot' => array(
                'id' => array('name' => 'id', 'require' => true, 'type' => 'int', 'min' => 1, 'desc' => '配置规则ID'),
            ),
            'delelteRightsRule' => array(
                'id' => array('name' => 'id', 'require' => true, 'type' => 'int', 'min' => 1, 'desc' => '待删除的配置规则ID'),
            ),
            'createNewRightsRule' => array(
                'rightsService' => array('name' => 'rights_service', 'require' => true, 'max' => 150, 'desc' => '接口服务'),
                'memberType' => array('name' => 'member_type', 'default' => 0, 'desc' => '开发者账号类型'),
                'userId' => array('name' => 'user_id', 'type' => 'int', 'default' => 0, 'desc' => '账号ID'),
                'appKey' => array('name' => 'app_key', 'default' => '', 'max' => 100, 'desc' => '应用key'),
                'isAllow' => array('name' => 'is_allow', 'type' => 'boolean', 'default' => true, 'desc' => '是否授权'),
            ),
            'getDevAppApis' => array(
                'appKey' => array('name' => 'app_key', 'require' => true, 'max' => '64', 'desc' => 'app_key，用于区分客户端应用'),
            ),
        );
    }

    /**
     * 获取全部接口及权限列表
     * @desc 获取全部接口及权限列表
     * @return int total 总接口数量
     * @return array apis 全部前台接口
     * @return string apis[].title 接口模块名称
     * @return array apis[].items 模块接口列表
     * @return string apis[].items[].service 接口名称，例如：App.Auth.ApplyToke
     * @return string apis[].items[].title 接口标题
     * @return int apis[].items[].is_allow 是否授权，0否1是
     * @return string apis[].class 类名
     * @return int apis[].total 模块接口总数量
     */
    public function getAllAppApis() {
        $rs = array('apis' => array(), 'total' => 0);
        $apisArr = ApiInfoUtil::getApiInfo('App');
        if (!empty($apisArr)) {
            $rs = $apisArr;
        }

        $rightsDomain = new RightsDomain();
        $appRights = $rightsDomain->getRightsForApp($this->appKey);

        foreach ($rs['apis'] as &$itRef) {
            foreach ($itRef['items'] as &$itemsRef) {
                $itemsRef['is_allow'] = isset($appRights[$itemsRef['service']]) ? intval($appRights[$itemsRef['service']]) : 1;
            }
        }

        return $rs;
    }

    /**
     * 授权
     * @desc 对app_key进行接口授权，支持批量
     * @return string service 回传本次授权接口
     */
    public function assignRights() {
        $rs = array('service' => $this->assignService);

        $rightsDomain = new RightsDomain();
        foreach ($this->assignService as $service) {
            $rightsDomain->assignRights($this->appKey, $service);
        }

        return $rs;
    }

    /**
     * 取消授权
     * @desc 对app_key取消接口授权，支持批量
     * @return string service 回传本次取消授权接口
     */
    public function removeRights() {
        $rs = array('service' => array());

        $rightsDomain = new RightsDomain();
        foreach ($this->removeService as $service) {
            $res = $rightsDomain->removeRights($this->appKey, $service);
            if($res){
                $rs['service'][] = $service;
            }
        }

        return $rs;
    }
    
    /**
     * 添加接口服务操作
     * @desc 添加一个新接口服务操作
     */
    public function addRightsService() {
        $rightsService = trim($this->rightsService);
        if (count(explode('.', $rightsService)) < 3) {
            throw new BadRequestException(\PhalApi\T("illegal interface service operation format"));
        }

        $domain = new RightsServiceDomain();
        $is_add = $domain->addRightsService($rightsService, $this->serviceDesc);

        $rs = array('is_add' => $is_add);
        return $rs;
    }
    
    /**
     * 删除接口服务操作
     * @desc 删除接口服务操作，同时删除全部的权限分配规则。
     */
    public function removeRightsService() {
        $domain = new RightsServiceDomain();
        $is_remove = $domain->removeRightsService($this->rightsService);

        $rs = array('is_remove' => $is_remove);
        return $rs;
        
    }

    /**
     * 获取全部接口服务操作列表
     * @desc 获取全部接口服务操作列表
     * @return array items 列表
     */
    public function listAllRightsService() {
        $domain = new RightsServiceDomain();
        $rs = array('items' => $domain->listAllRightsService());
        return $rs;
    }

    /**
     * 获取全部接口权限(按开发者分组)
     * @desc 针对全部开发者账号类型，获取全部接口权限状态。
     * @return array items 列表
     * @return array dev_types 开发者类型
     */
    public function listAllRightsForDeveloperType() {
        $domain = new RightsDomain();
        $rs = $domain->listAllRightsForDeveloperType();
        return $rs;
    }

    /**
     * 指派或撤销授权
     * @desc 针对开发者账号类型，指派或撤销接口服务的授权。
     * @return boolean is_allow 最终的权限状态
     */
    public function assignRightsForDevTypeOrNot() {
        $domain = new RightsDomain();
        $rs = array('is_allow' => $domain->assignRightsForDevTypeOrNot($this->rightsService, $this->memberType));
        return $rs;
    }

    /**
     * 获取接口权限规则配置
     * @desc 获取搜索接口权限规则配置列表数据，支持搜索。
     * @return array items 规则列表
     * @return int total 总数
     * @return array dev_types 开发者账号类型
     */
    public function searchRightsList() {
        $domain = new RightsDomain();
        $rs = $domain->searchRightsList($this->rightsService, $this->memberType, $this->userId, $this->appKey, $this->page, $this->perpage);
        return $rs;
    }

    /**
     * 为ID指派或撤销授权
     * @desc 针对配置规则ID，指派或撤销接口服务的授权。
     * @return boolean is_allow 最终的权限状态
     */
    public function assignRightsOrNot() {
        $domain = new RightsDomain();
        $rs = array('is_allow' => $domain->assignRightsOrNot($this->id));
        return $rs;
    }

    /**
     * 删除规则配置
     * @desc 根据ID删除规则配置
     */
    public function delelteRightsRule() {
        $domain = new RightsDomain();
        $is_deleted = $domain->delelteRightsRule($this->id);
        return array('is_deleted' => $is_deleted ? true : false);
    }

    /**
     * 创建新的权限分配规则
     * @desc 创建新的权限分配规则，规则不能重复
     * @return boolean is_add 是否添加成功，已存在时不会重复创建
     */
    public function createNewRightsRule() {
        if (!empty($this->appKey)) {
            $appDomain = new AppsDomain();
            $cfg = $appDomain->getApp($this->appKey);
            if (empty($cfg)) {
                throw new BadRequestException(\PhalApi\T("application does not exist"));
            }
        }
        
        if (!empty($this->userId)) {
            $userDomain = new UserDomain();
            $userProfile = $userDomain->profileByUid($this->userId);
            if (empty($userProfile)) {
                throw new BadRequestException(\PhalApi\T("account does not exist or has been deleted"));
            }
        }
        
        $domain = new RightsDomain();
        $is_add = $domain->createNewRightsRule($this->rightsService, $this->memberType, $this->userId, $this->appKey, $this->isAllow);
        if (!$is_add) {
            throw new BadRequestException(\PhalApi\T("permission rule already exists, cannot be added repeatedly"));
        }
        
        return array('is_add' => $is_add);
    }
    
    
    /**
     * 获取全部接口及权限列表
     * @desc 获取全部接口及权限列表
     * @return int total 总接口数量
     * @return array apis 全部前台接口
     * @return string apis[].title 接口模块名称
     * @return array apis[].items 模块接口列表
     * @return string apis[].items[].service 接口名称，例如：App.Auth.ApplyToke
     * @return string apis[].items[].title 接口标题
     * @return int apis[].items[].is_allow 是否授权，0否1是
     * @return string apis[].class 类名
     * @return int apis[].total 模块接口总数量
     */
    public function getDevAppApis() {
        $domain = new AppsDomain();
        $cfg = $domain->getApp($this->appKey);
        
        if (empty($cfg)) {
            throw new BadRequestException(\PhalApi\T("application does not exist"));
        }
        
        $rightsDomain = new RightsDomain();
        $appRights = $rightsDomain->getRightsForDevApp($cfg['uid'], $this->appKey);
        
        return array('apis' => $appRights);
    }
}
